<?php if (!defined('PmWiki')) exit();

/*
 flowPlayer,  PmWiki flowPlayer markup
 Author: Gianpaolo Terranova (gianpaoloterranova@gmail.com)
 Website: http://www.terranovanet.it
*/

/*

History

August 12th, 2015: update by Jean-Pierre Chrétien
to make the file PHP >= 5.5 compatible (remove the "e" modifier
in substitution strings)

*/

$RecipeInfo['flowPlayer']['Version']='2015-08-12';

SDV($FPObjBaseUrl, $ScriptUrl."/wiki/cookbook/flowplayer/");
SDV($FPJsUrl, $ScriptUrl."/wiki/cookbook/flowplayer/flashembed.min.js");
SDV($HelperJsUrl, $ScriptUrl."/wiki/cookbook/flowplayer/addloadevent.js");

$HTMLHeaderFmt['flowplayer'] =
"<script type=\"text/javascript\" src=\"".$FPJsUrl."\"></script>
<script type=\"text/javascript\" src=\"".$HelperJsUrl."\"></script>\n";

$fp_params[0] = array (
    'src' => 'Dark',
    'width' => 540,
    'height' => 400,
    'bgcolor' => '#ffffff'
);
    
$fp_params[1] = array (
//Common
    'videoFile' => '',
    'baseURL' => '',
    'autoPlay' => '',
    'autoBuffering' => '',
    'usePlayOverlay' => '',
    'splashImageFile' => '',
    'initialScale' => '',
    'initialVolumePercentage' => '',
    'videoHeight' => '',
    'useNativeFullScreen' => '',
    'useHwScaling' => '',
    'fullScreenScriptURL' => '',
    'bufferLength' => '',
    'startingBufferLength' => '',
    'useSmoothing' => '',
    'videoLink' => '',
    'emailPostUrl' => '',
    'emailVideoLink' => '',
    'emailDefaultMessage' => '',
//playlist
    'autoRewind' => '',
    'playList' => '',
    'loop' => '',
    'noVideoClip' => '',
//skinning
    'controlBarGloss' => '',
    'controlsOverVideo' => '',
    'controlBarBackgroundColor' => '',
    'watermarkUrl' => '',
    'showWatermark' => '',
    'watermarkLinkUrl' => '',
    'bufferingAnimationColor' => '',
    'bufferBarColor1' => '',
    'bufferBarColor2' => '',
    'progressBarColor1' => '',
    'progressBarColor2' => '',
    'progressBarBorderColor1' => '',
    'progressBarBorderColor2' => '',
    'controlsAreaBorderColor' => '',
    'hideControls' => '',
    'menuItems' => '',
    'showFullScreenButton' => '',
    'showStopButton' => '',
    'showPlayButton' => '',
    'showScrubber' => '',
    'showVolumeSlider' => '',
    'showMuteVolumeButton' => '',
    'showMenu' => '',
    'showPlayListButtons' => '',
    'timeDisplayFontColor' => ''
    );

Markup_e('FlowPlayer', 'inline','/\\(:flowplayer\s*(.*?)\s*:\\)/', PCCF('return ShowFlowPlayer($m[1]);'));

function ShowFlowPlayer($args){
  global $IsJsEnabled;
  global $FPObjBaseUrl;
  global $fp_params;

  SDV($IsJsEnabled,1);
  if (!$IsJsEnabled) return '';

  $args = ParseArgs($args); 
  $fp_config = array( 0 => '', 1 => '');

  foreach ($fp_config as $k => $v) {
    foreach ($fp_params[$k] as $key => $value) {
	${$key} = getArg($args,array($key),$value);
	if (${$key}=='') continue;
	if ($key=='src') ${$key} = $FPObjBaseUrl."FlowPlayer".${$key}.".swf";
	if (${$key}=='false' || ${$key}=='true')
	$fp_config[$k] .= "$key: ${$key}, ";
	else $fp_config[$k] .= "$key: '${$key}', ";
    }
    $fp_config[$k] = substr($fp_config[$k], 0, -2);
  }
  
  if (strlen($videoFile)<1) return '';

  $random = (rand(0,9999));

  return  Keep("<script>
  function loadmovie".$random."() {
    flashembed(\"movie".$random."\", 
      {".$fp_config[0]." },
      {config:{".$fp_config[1]."}} 
    ); 
  }
  addLoadEvent( loadmovie".$random." );
</script>
<div id=\"movie".$random."\"></div>\n");

}

#-------------------------------------------------------------------------------
if (!function_exists("getArg")){
  function getArg($args,$names,$default=null){
    if (is_string($names)){
      if (isset($args[$names])) return $args[$names];
      return $default;
    }
    if (is_array($names)){foreach($names as $n){if (isset($args[$n])) return $args[$n];}}
    return $default;
  }
 }

